'////////////////////////////////////////////////////////////////////////////////
'//	Add Clone
'////////////////////////////////////////////////////////////////////////////////
'counter1=number of rezes / counter2=scale / counter3=free / counter4=free / counter5=free
Function	AddClone(xpos:Float,ypos:Float)
	Local	i:tNME
	Local	done:Int
	Local	dis:Float

	i:tNME = New tNME
	i.t=6
	i.mode=0
	i.collrad=16

	done=0
	If xpos=0 And ypos=0
		Repeat
			i.x=Rand(WINleft+i.collrad,WINright-i.collrad)
			i.y=Rand(WINtop+i.collrad,WINbot-i.collrad)
			dis=Sqr(((i.x-PLAYERx)*(i.x-PLAYERx))+((i.y-PLAYERy)*(i.y-PLAYERy)))
			If dis>(PLAYERcollrad*8)
				done=1
			End If
		Until(done=1)
	Else
		i.x=xpos
		i.y=ypos
	End If
	i.ang=Rand(0,359)'ATan2(PLAYERx-i.x,PLAYERy-i.y)
	i.speed=0
	i.img=GFXnme09
	i.xscale=1
	i.yscale=1
	i.alpha=0
	i.blend=LIGHTBLEND
	i.rot=(-i.ang)+180
	i.r=255
	i.g=64
	i.b=64
	i.energy=50
	i.score=150
	i.counter1=0
	i.counter2=1	
	i.iamtheone=0
	If i.x<(WINleft+i.collrad)
		i.x=(WINleft+i.collrad)
	Else
		If i.x>(WINright-i.collrad)
			i.x=(WINright-i.collrad)
		End If
	End If

	If i.y<(WINtop+i.collrad)
		i.y=(WINtop+i.collrad)
	Else
		If i.y>(WINbot-i.collrad)
			i.y=(WINbot-i.collrad)
		End If
	End If
	ListAddLast(NMElist,i)

	AddSFX(cSFXnme07spawn,i.x)

End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Clone
'////////////////////////////////////////////////////////////////////////////////
Function	DoClone(i:tNME)

	Select	i.mode
		Case	0
			RezInClone(i)
		Case	1
			DoCloneSearch(i)
		Case	2
			KillClone(i)
	End Select
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Rez In Clone
'////////////////////////////////////////////////////////////////////////////////
'counter1=number of rezes / counter2=scale / counter3=free / counter4=free / counter5=free
Function	RezInClone(i:tNME)
	Local	la:Float

	AddImage(i.img,i.x-WINDOWx,i.y-WINDOWy,0,i.r,i.g,i.b,i.alpha,i.rot,i.counter2,i.counter2,LIGHTBLEND)

	AddImage(i.img,i.x-WINDOWx,i.y-WINDOWy,0,i.r,i.g,i.b,i.alpha,i.rot,(i.counter2+1)Mod 2,(i.counter2+1)Mod 2,LIGHTBLEND)

	i.alpha:+0.025

	i.counter2:+0.125

	If i.counter2=2
		i.counter2=1
		i.counter1:+1
		If i.counter1=6
			i.alpha=1
			i.counter1=0
			i.counter3=0
			i.counter4=0
			i.counter5=0
			i.mode=1
			la=ATan2(PLAYERx-i.x,PLAYERy-i.y)+180
			If (la-i.ang)>180
				la:-360
			Else
				If (la-i.ang)<-180
					la:+360
				End If
			End If

			If la>(i.ang)
				i.counter2=0
			Else
				If la<(i.ang)
					i.counter2=1
				End If
			End If
		End If
	End If
	'gridpoint.push(i.x-WINleft,i.y-WINtop,i.collrad+(i.alpha*2),10-(i.alpha*5))
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Clone Search
'////////////////////////////////////////////////////////////////////////////////
'counter1=mode / counter2=rot dir / counter3=distance / counter4=Shield Anim / counter5=max seed
Function	DoCloneSearch(i:tNME)
	Local	la:Float
	Local	big:Float
	Local	lil:Float
	Local	ox:Float
	Local	oy:Float
	Local	j:tBULLET
	Local	shield:Int

	shield=0

	Select i.counter1
		Case	0'Search and rotate
			la=ATan2(PLAYERx-i.x,PLAYERy-i.y)+180
			If i.counter2=0
				i.ang=(i.ang+2)Mod 360
			Else
				i.ang=(i.ang-2)Mod 360
				If i.ang<0
					i.ang:+360
				End If
			End If
			i.rot=(-i.ang)+180

			big=Max(la,i.ang)
			lil=Min(la,i.ang)
			If (big-lil)<5
				i.counter1=1
				i.counter2=0
				i.counter3=0
				i.counter5=Float(PLAYERMAXACCEL*2.0)
				i.tabx[0]=0
			End If
		Case	1'move
			If i.speed<i.counter5
				i.speed:+0.25
			Else
				If i.speed>0
					i.speed:-0.125
				End If
			End If

			i.tabx[0]:+1
			If i.tabx[0]=250
				i.counter2=2
			End If

			i.counter3=Sqr(((i.x-PLAYERx)*(i.x-PLAYERx))+((i.y-PLAYERy)*(i.y-PLAYERy)))
			If i.counter3<100 And i.counter2=0
				i.counter2=1
			End If

			If i.counter3>100 And i.counter2=1
				i.counter2=2
			End If

			If i.counter2=2
				If i.counter5>0
					i.counter5:-0.125
				Else
					i.counter1=0
					la=ATan2(PLAYERx-i.x,PLAYERy-i.y)+180
					If (la-i.ang)>180
						la:-360
					Else
						If (la-i.ang)<-180
							la:+360
						End If
					End If

					If la>(i.ang)
						i.counter2=0
					Else
						If la<(i.ang)
							i.counter2=1
						End If
					End If
				End If
			End If	

			la=ATan2(PLAYERx-i.x,PLAYERy-i.y)+180
			If (la-i.ang)>180
				la:-360
			Else
				If (la-i.ang)<-180
					la:+360
				End If
			End If

			If la>(i.ang)
				i.ang:+1
				i.ang=(i.ang Mod 360)
			Else
				If la<(i.ang)
					i.ang:-1
					i.ang=(i.ang Mod 360)
				End If
			End If

			i.rot=(-i.ang)+180

			ox=i.x
			oy=i.y

			i.x=ox+Sin(i.ang+180)*i.speed
			i.y=oy+Cos(i.ang+180)*i.speed

			If i.x<(WINleft+i.collrad)
				i.x=(WINleft+i.collrad)
			Else
				If i.x>(WINright-i.collrad)
					i.x=(WINright-i.collrad)
				End If
			End If

			If i.y<(WINtop+i.collrad)
				i.y=(WINtop+i.collrad)
			Else
				If i.y>(WINbot-i.collrad)
					i.y=(WINbot-i.collrad)
				End If
			End If

			'For j:tBULLET = EachIn BULLETlist
			'	If Sqr(((i.x-j.x)*(i.x-j.x))+((i.y-j.y)*(i.y-j.y)))<64
			'		shield=1
			'	End If
			'Next
	End Select

	For j:tBULLET = EachIn BULLETlist
		If Sqr(((i.x-j.x)*(i.x-j.x))+((i.y-j.y)*(i.y-j.y)))<64
			shield=1
		End If
	Next

	AddImage(i.img,i.x-WINDOWx,i.y-WINDOWy,0,i.r,i.g,i.b,i.alpha,i.rot,i.xscale,i.yscale,LIGHTBLEND)
	If shield=1
		AddImage(GFXnme09shield,i.x-WINDOWx,i.y-WINDOWy,i.counter4,i.r+64,i.g+64,i.b,i.alpha,i.rot+180,i.xscale+1,i.yscale+2,LIGHTBLEND)
		gridpoint.shockwave(i.x-WINleft,i.y-WINtop)
	End If

	i.counter4:+1
	If i.counter4>=4
		i.counter4=0
	End If
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Kill Clone
'////////////////////////////////////////////////////////////////////////////////
Function	KillClone(i:tNME)
	Local	part:tPART

	AddExplosion(i.x,i.y)

	part:tPART = New tPART
	part.accel=0.0000001
	part.accelchange=0
	part.ang=0
	part.angchange=0
	part.x=i.x
	part.y=i.y
	part.rot=i.rot
	part.rotchange=0
	part.alpha=1
	part.xscale=i.xscale
	part.yscale=i.yscale
	part.img=GFXnme09
	part.blend=LIGHTBLEND
	part.r=i.r
	part.g=i.g
	part.b=i.b
	part.collrad=0
	If i.iamtheone=0
		part.t=1
		part.alphachange=-0.05
		part.xscalechange=0.075
		part.yscalechange=0.075
	Else
		part.t=2
		part.alphachange=0
		part.xscalechange=0
		part.yscalechange=0
		part.rcolchange=1
		part.gcolchange=8
		part.bcolchange=1
	End If
	ListAddLast(particlelist,part)

	UpdateScore(i.score,i.x,i.y)

	nmelist.remove i
	If i.score<>0
		debugTOTALKILLED:+1
		debugTOTALKILLEDNODEATH:+1
		AddSFX(cSFXnmekill,i.x)
		KILLtype[i.t]:+1
	End If
	'BORDERz1[BORDERbuf,i.x/32,i.y/32]=BORDERsplash
	gridpoint.shockwave(i.x-GRIDxoff,i.y-GRIDyoff)
End Function




