'////////////////////////////////////////////////////////////////////////////////
'//	Add Spinner
'////////////////////////////////////////////////////////////////////////////////
'counter1=number of rezes / counter2=scale / counter3=free / counter4=free / counter5=free
Function	AddScare(xpos:Float,ypos:Float,spawn:Int=1)
	Local	i:tNME
	Local	done:Int
	Local	dis:Float

	i:tNME = New tNME
	i.t=3
	i.mode=0
	i.collrad=12

	done=0
	If xpos=0 And ypos=0
		Repeat
			i.x=Rand(WINleft+i.collrad,WINright-i.collrad)
			i.y=Rand(WINtop+i.collrad,WINbot-i.collrad)
			dis=Sqr(((i.x-PLAYERx)*(i.x-PLAYERx))+((i.y-PLAYERy)*(i.y-PLAYERy)))
			If dis>(PLAYERcollrad*8)
				done=1
			End If
		Until(done=1)
	Else
		i.x=xpos
		i.y=ypos
	End If
	i.ang=ATan2(PLAYERy-i.y,PLAYERx-i.x)
	i.speed=0
	i.img=GFXnme05
	i.xscale=1
	i.yscale=1
	i.alpha=0
	i.blend=LIGHTBLEND
	i.rot=Rand(0,359)
	i.r=24
	i.g=255
	i.b=24
	i.energy=50
	i.score=100
	i.counter1=0
	i.counter2=1	
	i.iamtheone=0
	If spawn=0
		i.alpha=1
		i.mode=1
		i.counter1=Rand(0,1)
		i.counter2=0
		i.counter3=0
		i.counter4=0
		i.counter5=0
	End If
	If i.x<(WINleft+i.collrad)
		i.x=(WINleft+i.collrad)
	Else
		If i.x>(WINright-i.collrad)
			i.x=(WINright-i.collrad)
		End If
	End If

	If i.y<(WINtop+i.collrad)
		i.y=(WINtop+i.collrad)
	Else
		If i.y>(WINbot-i.collrad)
			i.y=(WINbot-i.collrad)
		End If
	End If
	ListAddLast(NMElist,i)

	AddSFX(cSFXnme04spawn,i.x)

End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Floater
'////////////////////////////////////////////////////////////////////////////////
Function	DoScare(i:tNME)

	Select	i.mode
		Case	0
			RezInScare(i)
		Case	1
			DoScareSearch(i)
		Case	2
			KillScare(i)
	End Select
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Rez In Floater
'////////////////////////////////////////////////////////////////////////////////
'counter1=number of rezes / counter2=scale / counter3=free / counter4=free / counter5=free
Function	RezInScare(i:tNME)
	AddImage(i.img,i.x-WINDOWx,i.y-WINDOWy,0,i.r,i.g,i.b,i.alpha,i.rot,i.counter2,i.counter2,LIGHTBLEND)

	AddImage(i.img,i.x-WINDOWx,i.y-WINDOWy,0,i.r,i.g,i.b,i.alpha,i.rot,(i.counter2+1)Mod 2,(i.counter2+1)Mod 2,LIGHTBLEND)

	i.alpha:+0.025

	i.counter2:+0.125

	If i.counter2=2
		i.counter2=1
		i.counter1:+1
		If i.counter1=6
			i.alpha=1
			i.mode=1
			i.counter1=Rand(0,1)
			i.counter2=0
			i.counter3=0
			i.counter4=0
			i.counter5=0
		End If
	End If
	'gridpoint.push(i.x-WINleft,i.y-WINtop,i.collrad+(i.alpha*2),10-(i.alpha*5))
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Floater Search
'////////////////////////////////////////////////////////////////////////////////
'counter1=SpinDirection / counter2=top speed / counter3=free / counter4=free / counter5=free
Function	DoScareSearch(i:tNME)
	Local	ox:Float
	Local	oy:Float
	Local	bul:tBULLET
	Local	colldis:Float
	Local	actdis:Float
	Local	collnormal:Float
	Local	movedis2:Float
	
	If i.counter1=0
		i.rot=(i.rot+5)Mod 360
	Else
		i.rot=(i.rot-5)Mod 360
	End If

	i.ang=ATan2(PLAYERx-i.x,PLAYERy-i.y)

	If i.counter3<i.ang
		i.counter3:+1
	Else
		If i.counter3>i.ang
			i.counter3:-1
		End If
	End If

	If i.speed<(PLAYERMAXACCEL*0.75)
		i.speed:+0.25
	Else
		If i.speed>0
			i.speed:-0.125
		End If
	End If

	ox=i.x
	oy=i.y

	i.x=ox+Sin(i.ang)*i.speed
	i.y=oy+Cos(i.ang)*i.speed

	For	bul:tBULLET = EachIn BULLETlist
		colldis=(bul.collrad+(i.collrad*3))
		actdis=Sqr(((i.x-bul.x)*(i.x-bul.x))+((i.y-bul.y)*(i.y-bul.y)))
		If actdis<colldis
			collnormal=ATan2(i.y-bul.y, i.x-bul.x)
			movedis2=(colldis-actdis)/2
			i.x=i.x + movedis2*Cos(collnormal)
			i.y=i.y + movedis2*Sin(collnormal)
			i.speed= -PLAYERMAXACCEL
		End If
	Next

	If i.x<(WINleft+i.collrad)
		i.x=(WINleft+i.collrad)
	Else
		If i.x>(WINright-i.collrad)
			i.x=(WINright-i.collrad)
		End If
	End If

	If i.y<(WINtop+i.collrad)
		i.y=(WINtop+i.collrad)
	Else
		If i.y>(WINbot-i.collrad)
			i.y=(WINbot-i.collrad)
		End If
	End If

	AddImage(i.img,i.x-WINDOWx,i.y-WINDOWy,0,i.r,i.g,i.b,i.alpha,i.rot,i.xscale,i.yscale,i.blend)

End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Kill Floater
'////////////////////////////////////////////////////////////////////////////////
Function	KillScare(i:tNME)
	Local	part:tPART

	AddExplosion(i.x,i.y)

	part:tPART = New tPART
	part.accel=0.0000001
	part.accelchange=0
	part.ang=0
	part.angchange=0
	part.x=i.x
	part.y=i.y
	part.rot=i.rot
	part.rotchange=0
	part.alpha=1
	part.xscale=i.xscale
	part.yscale=i.yscale
	part.img=GFXnme05
	part.blend=LIGHTBLEND
	part.r=i.r
	part.g=i.g
	part.b=i.b
	part.collrad=0
	If i.iamtheone=0
		part.t=1
		part.alphachange=-0.05
		part.xscalechange=0.075
		part.yscalechange=0.075
	Else
		part.t=2
		part.alphachange=0
		part.xscalechange=0
		part.yscalechange=0
		part.rcolchange=1
		part.gcolchange=8
		part.bcolchange=1
	End If
	ListAddLast(particlelist,part)

	UpdateScore(i.score,i.x,i.y)

	nmelist.remove i
	If i.score<>0
		debugTOTALKILLED:+1
		debugTOTALKILLEDNODEATH:+1
		AddSFX(cSFXnmekill,i.x)
		KILLtype[i.t]:+1
	End If
	'BORDERz1[BORDERbuf,i.x/32,i.y/32]=BORDERsplash
	gridpoint.shockwave(i.x-GRIDxoff,i.y-GRIDyoff)
End Function


