'////////////////////////////////////////////////////////////////////////////////
'//	Variables
'////////////////////////////////////////////////////////////////////////////////
Const	cSFXmenumove:Int=0
Const	cSFXmenuaccept:Int=1
Const	cSFXplayerstart:Int=2
Const	cSFXplayerfire1:Int=3
Const	cSFXplayerfire2:Int=4
Const	cSFXplayerfire3:Int=5
Const	cSFXplayershield:Int=6
Const	cSFXplayerbomb:Int=7
Const	cSFXextralife:Int=8
Const	cSFXextrabomb:Int=9
Const	cSFXaward:Int=10
Const	cSFXnmekill:Int=11
Const	cSFXnme01spawn:Int=12
Const	cSFXnme02spawn:Int=13
Const	cSFXnme03spawn:Int=14
Const	cSFXnme04spawn:Int=15
Const	cSFXnme05spawn:Int=16
Const	cSFXnme06spawn:Int=17
Const	cSFXnme07spawn:Int=18
Const	cSFXnme08spawn:Int=19
Const	cSFXnme09spawn:Int=20
Const	cSFXnme10spawn:Int=21
Const	cSFXplayerexp:Int=22
Const	cSFXbombhit:Int=23
Const	cSFXmultiply:Int=24
Const	cSFXholeexp:Int=25
Const	cSFXhole:Int=26

Global	SFXvolume:Float=1
Global	MUSICvolume:Float=1

Global	cSFXplaying:Int[128]
Global	cSFXchannel:TChannel[128]
Global	cSFXpan:Float[128]
'////////////////////////////////////////////////////////////////////////////////
'//	Clear SFX
'////////////////////////////////////////////////////////////////////////////////
Function	ClearSFX()
	Local	i:Int

	For i=0 To 127
		cSFXplaying[i]=0
		cSFXpan[i]=0
	Next
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do SFX
'////////////////////////////////////////////////////////////////////////////////
Function	AddSFX(snd:Int,xpos:Float)
	Local	chan:TSound[]=[SFXmenubeep01,SFXmenubeep02,SFXplayerrez,SFXplayerfire01,SFXplayerfire02,SFXplayerfire03,SFXplayershield,SFXplayerbomb,SFXextralife,SFXextrabomb,SFXaward,SFXnme01exp,SFXnme01rez,SFXnme02rez,SFXnme03rez,SFXnme04rez,SFXnme05rez,SFXnme06rez,SFXnme07rez,SFXnme08rez,SFXnme01rez,SFXnme01rez,SFXplayerexp,SFXplayerbombhit,SFXmultiply,SFXholeexp,SFXhole]
	Local	pan:Float

	If cSFXplaying[snd]=0
		cSFXchannel[snd]=PlaySound(chan[snd])
		SetChannelVolume(cSFXchannel[snd],SFXvolume)
		If xpos=-1
			pan=0
		Else
			pan=(((xpos-WINleft)-(PLAYERx-WINleft))/512)
		End If
		pan=(pan+cSFXpan[snd])/2
		SetChannelPan(cSFXchannel[snd],pan)
		SetChannelDepth(cSFXchannel[snd],0)
		cSFXplaying[snd]=1
	End If
End Function
