Global	UPLOADscoretable:Int[]=[0,0,0,0]
Global	UPLOADsizetable:Int[]=[4,1,1,4]
Global	UPLOADname:String=""
Global	UPLOADtext:String

'////////////////////////////////////////////////////////////////////////////////
'//	Encode Hiscore
'////////////////////////////////////////////////////////////////////////////////
Function	uuencode_generic:String(game_number:Int,num_scores:Int,scores:Int[],sizes:Int[])

	Local	dest:String=""

'	Local	decode:String="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+@"
	Local	decode:String[]=["A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z","a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z","0","1","2","3","4","5","6","7","8","9","+","@"]
	Local	uu:Byte[Byte(30)]

	Local	i:Int
	Local	j:Int
	Local	pos_in_uu:Int=4
	Local	score_size:Int
	Local	xor:Byte=105
	Local	add:Int=0
	Local	real_length:Int=0
	Local	temp_num:Int
	Local	pos_dest:Int=0
	Local	added_bytes:Int=0

	For i=0 To num_scores-1
		DebugLog(scores[i]+","+sizes[i])
	Next

	uu[0]=(MilliSecs() Shr 8) & 255		'Time Stamp High
	uu[1]=MilliSecs() & 255				'Time Stamp Low
	uu[2]=(game_number Shr 8) & 255		'Game Number High
	uu[3]=game_number & 255				'Game Number Low

	'Lets put our scores in the code
	For i=0 To num_scores-1
		score_size = sizes[i]
		For j=0 To score_size-1
			uu[pos_in_uu] = (scores[i]Shr(((score_size-1)-j)*8))&255
			pos_in_uu:+1
		Next
	Next

	'Start XOR-ing the code And doing checksum

	For i=0 To pos_in_uu-1
		add = add+uu[i]				'First calc checksum
		uu[i]=uu[i] ~ xor			'XOR the value
		xor = uu[i]					'Make the XOR value last value, so it changes
	Next

	uu[pos_in_uu] = add & 255		'Checksum	(Not xor-ed)
	pos_in_uu:+1

	real_length = pos_in_uu			'Remember the real length of the code

	'Add the "filler" ZER0 bytes at the End of the code To make it a multiply of 3 !	
	If (real_length Mod 3) <> 0
		'We need To fill, Not a multiply of 3
	    added_bytes = 3-(real_length Mod 3)
	End If

	For i=0 To added_bytes-1
		uu[real_length+i] = 0
		pos_in_uu:+1
	Next

	'Do actual uuencoding here
	
	For i=0 To (pos_in_uu/3)-1											'UUENCODE takes the bytes in chunks of 3
		temp_num = (uu[i*3]*256*256)+(uu[i*3+1]*256)+uu[i*3+2]			'Calculate 24 bit value from 3 bytes
		For j=0 To 4-1
 			'dest[pos_dest] = decode[(temp_num Shr (6*(3-j)))&63]		'Do the ASCII chars from 6 bit parts
 			'dest=dest+ Mid$(decode,((temp_num Shr (6*(3-j)))&63)+1,1)	'Do the ASCII chars from 6 bit parts
 			dest:+ decode[(temp_num Shr (6*(3-j)))&63]					'Do the ASCII chars from 6 bit parts
			pos_dest:+1
		Next
	Next


	'Remove the added 'A' chars at the end ... otherwise it will just terminate the string
	'dest[pos_dest-added_bytes] = 0;
	DebugLog(dest)
	dest=Left$(dest,pos_dest-added_bytes)

	Return(dest)
End Function
