'////////////////////////////////////////////////////////////////////////////////
'//	Debug Variables
'////////////////////////////////////////////////////////////////////////////////
Global	debugTOTALKILLED:Long
Global	debugTOTALKILLEDNODEATH:Long

Global	DEBUG:Int=0
Global	DEBUGdown:Int=0

Global	poo:Float
Global	poo2:Float
'////////////////////////////////////////////////////////////////////////////////
'//	Print Small (Does NOT use the draw List!)
'////////////////////////////////////////////////////////////////////////////////
Function PrintSmall(ss:String,x:Int,y:Int,col:Int=7)
	Local	i:Int
	Local	cr:Int

	SetColor(255,255,255)
	SetRotation(0)
	SetScale(1,1)
	SetAlpha(1)
	SetBlend(ALPHABLEND)

	x:+4
	y:+4

	For i=0 To Len(ss$)-1
		cr=(Asc(Mid$(ss$,i+1,1))-32)
		If cr=(Asc("`")-32)
			col=(Asc(Mid$(ss$,i+2,1))-96)
			i=i+1
		Else
			If cr<>0
				DrawImage(GFXfontsmall,x,y,cr+(col*96))
			End If
			x:+8
		End If
	Next
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Debug
'////////////////////////////////////////////////////////////////////////////////
Function	DoDebug()
	If KeyDown(KEY_F12) Or KeyDown(KEY_F8)
		If DEBUGdown=0
			DEBUG=(DEBUG+1) Mod 2
			DEBUGdown=1
		End If
	Else
		DEBUGdown=0
	End If

	If DEBUG=1
		DrawDebug()
	Else
		FPS()
	End If
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Draw Debug
'////////////////////////////////////////////////////////////////////////////////
Function	DrawDebug()
	Local	i:Int
	FPS()

	PrintSmall("FPS:            `f"+FPScur,0,GFXh-(8*1),7)
	PrintSmall("Memorry Alloced:`f"+(GCMemAlloced()/1024)+"k",0,GFXh-(8*2),7)
	PrintSmall("Total Images:   `f"+DRAWlist.count(),0,GFXh-(8*3),7)
	PrintSmall("Bullets:        `f"+BULLETlist.count(),0,GFXh-(8*4),7)
	PrintSmall("Particles:      `f"+PARTICLElist.count(),0,GFXh-(8*5),7)
	PrintSmall("Bad Guys:       `f"+NMElist.count(),0,GFXh-(8*6),7)
	PrintSmall("Total Killed:   `f"+debugTOTALKILLED,0,GFXh-(8*7),7)
	PrintSmall("Killed:         `f"+debugTOTALKILLEDNODEATH,0,GFXh-(8*8),7)
	PrintSmall("Next Multiplier:`f"+PLAYERmultiplydelta,0,GFXh-(8*9),7)
	PrintSmall("Attack Max:     `f"+ATTACKmax,0,GFXh-(8*10),7)
	PrintSmall("Attack Mode:    `f"+ATTACKmode,0,GFXh-(8*11),7)
	PrintSmall("Attack Skill:   `f"+ATTACKskill,0,GFXh-(8*12),7)

	PrintSmall(poo,0,GFXh-(8*14),7)
	PrintSmall(poo2,0,GFXh-(8*15),7)

End Function

