'////////////////////////////////////////////////////////////////////////////////
'//	Variables
'////////////////////////////////////////////////////////////////////////////////
'Const	EXPLOSIONPARTICLEMAX:Int=1
Const	SNAKETAILLENGTH:Float=24
Const	SNAKETAILSTEP:Int=4

Type	tNME
	Field	t:Int
	Field	mode:Int
	Field	x:Float
	Field	y:Float
	Field	ang:Float
	Field	speed:Float
	Field	collrad:Float
	Field	img:TImage
	Field	xscale:Float
	Field	yscale:Float
	Field	rot:Float
	Field	alpha:Float
	Field	blend:Int
	Field	r:Int
	Field	g:Int
	Field	b:Int
	Field	energy:Float
	Field	score:Int
	Field	counter1:Float
	Field	counter2:Float
	Field	counter3:Float
	Field	counter4:Float
	Field	counter5:Float
	Field	tabx:Float[SNAKETAILLENGTH*5]
	Field	taby:Float[SNAKETAILLENGTH*5]
	Field	iamtheone:Int
End Type
Global NMElist:TList=CreateList()

Global	KILLtype:Int[11]

Global	GFXnme01:TImage
Global	GFXnme02:TImage
Global	GFXnme03:TImage
Global	GFXnme04:TImage
Global	GFXnme05:TImage
Global	GFXnme06:TImage
Global	GFXnme07:TImage
Global	GFXnme07b:TImage
Global	GFXnme08:TImage
Global	GFXnme09:TImage
Global	GFXnme09shield:TImage
Global	GFXnme10:TImage
Global	GFXnme10b:TImage
Global	GFXnme10c:TImage

Global	GFXpartex01:TImage
Global	GFXpartex02:TImage

Global	SFXnme01exp:TSound
Global	SFXnme01rez:TSound
Global	SFXnme02rez:TSound
Global	SFXnme03rez:TSound
Global	SFXnme04rez:TSound
Global	SFXnme05rez:TSound
Global	SFXnme06rez:TSound
Global	SFXnme07rez:TSound
Global	SFXnme08rez:TSound

Global	SFXholeexp:TSound
Global	SFXholehit:TSound
Global	SFXhole:TSound

'////////////////////////////////////////////////////////////////////////////////
'//	Do Nme
'////////////////////////////////////////////////////////////////////////////////
Function	DoNme()
	Local	i:tNME
	Local	j:tNME
	Local	k:tBULLET

	Local	colldis:Float
	Local	actdis:Float
	Local	collnormal:Float
	Local	movedis1:Float
	Local	movedis2:Float

	Local	lad:Float
	Local	lad2:Float
	Local	la:Float

	For	i:tNME = EachIn NMElist
		Select	i.t
			Case	0
				DoSpinner(i)
			Case	1
				DoFloater(i)
			Case	2
				DoSplitter(i)
			Case	3
				DoScare(i)
			Case	4
				DoSwamer(i)
			Case	5
				DoSnake(i)
			Case	6
				DoClone(i)
			Case	7
				DoHole(i)
			Case	8
				DoHoleSpore(i)
			Case	10
				DoSpawn(i)
		End Select
	Next

	For i:tNME = EachIn NMElist	'NME Keep Apart
		For j:tNME = EachIn NMElist
			If i<>j 'And i.t<>7
				If i.t=j.t
					If i.t=10'Spawner
						colldis=(j.collrad+i.collrad)
						actdis=Sqr(((i.counter4-j.counter4)*(i.counter4-j.counter4))+((i.counter5-j.counter5)*(i.counter5-j.counter5)))
						If actdis<colldis
							collnormal=ATan2(i.counter5-j.counter5, i.counter4-j.counter4)
							movedis1=(colldis-actdis)
							movedis2=(colldis-actdis)
							j.counter4=j.counter4 + moveDis1*Cos((collNormal+180))
							j.counter5=j.counter5 + moveDis1*Sin((collNormal+180))
							i.counter4=i.counter4 + movedis2*Cos(collnormal)
							i.counter5=i.counter5 + movedis2*Sin(collnormal)
						End If
					Else
						colldis=(j.collrad+i.collrad)
						actdis=Sqr(((i.x-j.x)*(i.x-j.x))+((i.y-j.y)*(i.y-j.y)))
						If actdis<colldis
							collnormal=ATan2(i.y-j.y, i.x-j.x)
							movedis1=(colldis-actdis)/4
							movedis2=(colldis-actdis)/4
							j.x=j.x + moveDis1*Cos((collNormal+180))
							j.y=j.y + moveDis1*Sin((collNormal+180))
							i.x=i.x + movedis2*Cos(collnormal)
							i.y=i.y + movedis2*Sin(collnormal)
						End If
					End If
				End If
			End If
		Next
	Next

	For i:tNME = EachIn NMElist	'Black Hole Attrackt NME
		For j:tNME = EachIn NMElist
			If i<>j And i.t=7
				If j.mode=1 And i.counter1=1
					lad=Sqr(((i.x-j.x)*(i.x-j.x))+((i.y-j.y)*(i.y-j.y)))
					If lad<(i.collrad+j.collrad)
						If j.t<>7
							i.energy:+(j.energy*2)
							i.score:+j.score
							j.score=0
							j.mode=2
						End If
					Else
						If lad<200
							la=ATan2(i.x-j.x, i.y-j.y)
							j.x=j.x+Sin(la)*(j.collrad/(lad/16))
							j.y=j.y+Cos(la)*(j.collrad/(lad/16))
							If j.t=10
								If j.tabx[0]>0
									j.tabx[0]:-2
								End If
							End If
						End If
					End If
				End If
			End If
		Next
	Next

	For i:tNME = EachIn NMElist	'Black Hole Attrackt Player
		If i.t=7 And i.counter1=1
			lad=Sqr(((i.x-PLAYERx)*(i.x-PLAYERx))+((i.y-PLAYERy)*(i.y-PLAYERy)))
			If lad<200
				la=ATan2(i.x-PLAYERx, i.y-PLAYERy)
				PLAYERx=PLAYERx+Sin(la)*(PLAYERcollrad/(lad/8))
				PLAYERy=PLAYERy+Cos(la)*(PLAYERcollrad/(lad/8))
			End If
		End If
	Next

	For i:tNME = EachIn NMElist	'Black Hole Push Bullet
		For k:tBULLET = EachIn BULLETlist
			If i.t=7 And i.counter1=1
				lad=Sqr(((i.x-k.x)*(i.x-k.x))+((i.y-k.y)*(i.y-k.y)))
				If lad<100 And lad>32
					la=ATan2(i.x-k.x, i.y-k.y)+180
					k.x=k.x+Sin(la)*(k.collrad/(lad/16))
					k.y=k.y+Cos(la)*(k.collrad/(lad/16))
				End If
			End If
		Next
	Next

End Function


